/****************************************************************************
**
** Copyright (C) 2016 The Qt Company Ltd.
** Contact: https://www.qt.io/licensing/
**
** This file is part of Qt for Python.
**
** $QT_BEGIN_LICENSE:LGPL$
** Commercial License Usage
** Licensees holding valid commercial Qt licenses may use this file in
** accordance with the commercial license agreement provided with the
** Software or, alternatively, in accordance with the terms contained in
** a written agreement between you and The Qt Company. For licensing terms
** and conditions see https://www.qt.io/terms-conditions. For further
** information use the contact form at https://www.qt.io/contact-us.
**
** GNU Lesser General Public License Usage
** Alternatively, this file may be used under the terms of the GNU Lesser
** General Public License version 3 as published by the Free Software
** Foundation and appearing in the file LICENSE.LGPL3 included in the
** packaging of this file. Please review the following information to
** ensure the GNU Lesser General Public License version 3 requirements
** will be met: https://www.gnu.org/licenses/lgpl-3.0.html.
**
** GNU General Public License Usage
** Alternatively, this file may be used under the terms of the GNU
** General Public License version 2.0 or (at your option) the GNU General
** Public license version 3 or any later version approved by the KDE Free
** Qt Foundation. The licenses are as published by the Free Software
** Foundation and appearing in the file LICENSE.GPL2 and LICENSE.GPL3
** included in the packaging of this file. Please review the following
** information to ensure the GNU General Public License requirements will
** be met: https://www.gnu.org/licenses/gpl-2.0.html and
** https://www.gnu.org/licenses/gpl-3.0.html.
**
** $QT_END_LICENSE$
**
****************************************************************************/

//workaround to access protected functions
#define protected public

// default includes
#include <shiboken.h>
#ifndef QT_NO_VERSION_TAGGING
#  define QT_NO_VERSION_TAGGING
#endif
#include <QDebug>
#include <pysidesignal.h>
#include <pysideproperty.h>
#include <pyside.h>
#include <pysideqenum.h>
#include <feature_select.h>
QT_WARNING_DISABLE_DEPRECATED

#include <typeinfo>
#include <iterator>

// module include
#include "pyside6_qtquick3d_python.h"

// main header
#include "qquick3dinstancing_instancetableentry_wrapper.h"

// inner classes

#include <cctype>
#include <cstring>



template <class T>
static const char *typeNameOf(const T &t)
{
    const char *typeName =  typeid(t).name();
    auto size = std::strlen(typeName);
#if defined(Q_CC_MSVC) // MSVC: "class QPaintDevice * __ptr64"
    if (auto lastStar = strchr(typeName, '*')) {
        // MSVC: "class QPaintDevice * __ptr64"
        while (*--lastStar == ' ') {
        }
        size = lastStar - typeName + 1;
    }
#else // g++, Clang: "QPaintDevice *" -> "P12QPaintDevice"
    if (size > 2 && typeName[0] == 'P' && std::isdigit(typeName[1])) {
        ++typeName;
        --size;
    }
#endif
    char *result = new char[size + 1];
    result[size] = '\0';
    memcpy(result, typeName, size);
    return result;
}


// Target ---------------------------------------------------------

extern "C" {
static int
Sbk_QQuick3DInstancing_InstanceTableEntry_Init(PyObject *self, PyObject *args, PyObject *kwds)
{
    SbkObject *sbkSelf = reinterpret_cast<SbkObject *>(self);
    PySide::Feature::Select(self);
    if (Shiboken::Object::isUserType(self) && !Shiboken::ObjectType::canCallConstructor(self->ob_type, Shiboken::SbkType< ::QQuick3DInstancing::InstanceTableEntry >()))
        return -1;

    ::QQuick3DInstancing::InstanceTableEntry *cptr{};
    Shiboken::AutoDecRef errInfo{};
    static const char *fullName = "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.__init__";
    SBK_UNUSED(fullName)
    int overloadId = -1;
    Shiboken::Conversions::PythonToCppConversion pythonToCpp[1];
    SBK_UNUSED(pythonToCpp)
    const Py_ssize_t numArgs = PyTuple_GET_SIZE(args);
    SBK_UNUSED(numArgs)
    PyObject *pyArgs[] = {0};

    // invalid argument lengths


    if (!PyArg_UnpackTuple(args, "InstanceTableEntry", 0, 1, &(pyArgs[0])))
        return -1;


    // Overloaded function decisor
    // 0: InstanceTableEntry::InstanceTableEntry()
    // 1: InstanceTableEntry::InstanceTableEntry(QQuick3DInstancing::InstanceTableEntry)
    if (numArgs == 0) {
        overloadId = 0; // InstanceTableEntry()
    } else if (numArgs == 1
        && (pythonToCpp[0] = Shiboken::Conversions::pythonToCppReferenceConversion(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], (pyArgs[0])))) {
        overloadId = 1; // InstanceTableEntry(QQuick3DInstancing::InstanceTableEntry)
    }

    // Function signature not found.
    if (overloadId == -1) goto Sbk_QQuick3DInstancing_InstanceTableEntry_Init_TypeError;

    // Call function/method
    switch (overloadId) {
        case 0: // InstanceTableEntry()
        {

            if (!PyErr_Occurred()) {
                // InstanceTableEntry()
                cptr = new ::QQuick3DInstancing::InstanceTableEntry();
            }
            break;
        }
        case 1: // InstanceTableEntry(const QQuick3DInstancing::InstanceTableEntry & InstanceTableEntry)
        {
            if (!Shiboken::Object::isValid(pyArgs[0]))
                return -1;
            ::QQuick3DInstancing::InstanceTableEntry cppArg0_local;
            ::QQuick3DInstancing::InstanceTableEntry *cppArg0 = &cppArg0_local;
            if (pythonToCpp[0].isValue())
                pythonToCpp[0](pyArgs[0], &cppArg0_local);
            else
                pythonToCpp[0](pyArgs[0], &cppArg0);


            if (!PyErr_Occurred()) {
                // InstanceTableEntry(QQuick3DInstancing::InstanceTableEntry)
                cptr = new ::QQuick3DInstancing::InstanceTableEntry(*cppArg0);
            }
            break;
        }
    }

    if (PyErr_Occurred() || !Shiboken::Object::setCppPointer(sbkSelf, Shiboken::SbkType< ::QQuick3DInstancing::InstanceTableEntry >(), cptr)) {
        delete cptr;
        return -1;
    }
    if (!cptr) goto Sbk_QQuick3DInstancing_InstanceTableEntry_Init_TypeError;

    Shiboken::Object::setValidCpp(sbkSelf, true);
    if (Shiboken::BindingManager::instance().hasWrapper(cptr)) {
        Shiboken::BindingManager::instance().releaseWrapper(Shiboken::BindingManager::instance().retrieveWrapper(cptr));
    }
    Shiboken::BindingManager::instance().registerWrapper(sbkSelf, cptr);


    return 1;

    Sbk_QQuick3DInstancing_InstanceTableEntry_Init_TypeError:
        Shiboken::setErrorAboutWrongArguments(args, fullName, errInfo);
        return -1;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry___copy__(PyObject *self)
{
    if (!Shiboken::Object::isValid(self))
        return {};
    auto &cppSelf = *reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    PyObject *pyResult = Shiboken::Conversions::copyToPython(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], &cppSelf);
    if (PyErr_Occurred() || !pyResult) {
        Py_XDECREF(pyResult);
        return {};
    }
    return pyResult;
}


static const char *Sbk_QQuick3DInstancing_InstanceTableEntry_PropertyStrings[] = {
    nullptr // Sentinel
};

static PyMethodDef Sbk_QQuick3DInstancing_InstanceTableEntry_methods[] = {

    {"__copy__", reinterpret_cast<PyCFunction>(Sbk_QQuick3DInstancing_InstanceTableEntry___copy__), METH_NOARGS},
    {nullptr, nullptr} // Sentinel
};

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_row0(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->row0)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX]));
        if (pyOut) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->row0))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->row0)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], &(cppSelf->row0), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_row0(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'row0' may not be deleted");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'row0', 'QVector4D' or convertible type expected");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->row0;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_row1(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->row1)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX]));
        if (pyOut) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->row1))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->row1)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], &(cppSelf->row1), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_row1(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'row1' may not be deleted");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'row1', 'QVector4D' or convertible type expected");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->row1;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_row2(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->row2)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX]));
        if (pyOut) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->row2))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->row2)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], &(cppSelf->row2), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_row2(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'row2' may not be deleted");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'row2', 'QVector4D' or convertible type expected");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->row2;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_color(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->color)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX]));
        if (pyOut) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->color))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->color)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], &(cppSelf->color), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_color(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'color' may not be deleted");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'color', 'QVector4D' or convertible type expected");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->color;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

static PyObject *Sbk_QQuick3DInstancing_InstanceTableEntry_get_instanceData(PyObject *self, void *)
{
    if (!Shiboken::Object::isValid(self))
        return nullptr;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    PyObject *pyOut = {};
    if (reinterpret_cast<void *>(&(cppSelf->instanceData)) == reinterpret_cast<void *>(cppSelf)) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::Object::findColocatedChild(reinterpret_cast<SbkObject *>(self), SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX]));
        if (pyOut) {
            Py_IncRef(pyOut);
            return pyOut;
        }
    } else if (Shiboken::BindingManager::instance().hasWrapper(&(cppSelf->instanceData))) {
        pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(&(cppSelf->instanceData)));
        Py_IncRef(pyOut);
        return pyOut;
    }
    pyOut = Shiboken::Object::newObject(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], &(cppSelf->instanceData), false, true);
    Shiboken::Object::setParent(self, pyOut);
    return pyOut;
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_set_instanceData(PyObject *self, PyObject *pyIn, void *)
{
    if (!Shiboken::Object::isValid(self))
        return 0;
    auto cppSelf = reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(self)));
    SBK_UNUSED(cppSelf)
    if (pyIn == nullptr) {
        PyErr_SetString(PyExc_TypeError, "'instanceData' may not be deleted");
        return -1;
    }
    Shiboken::Conversions::PythonToCppConversion pythonToCpp;
    if (!(pythonToCpp = Shiboken::Conversions::pythonToCppValueConversion(SbkPySide6_QtGuiTypes[SBK_QVECTOR4D_IDX], (pyIn)))) {
        PyErr_SetString(PyExc_TypeError, "wrong type attributed to 'instanceData', 'QVector4D' or convertible type expected");
        return -1;
    }

    auto &cppOut_ptr = cppSelf->instanceData;
    pythonToCpp(pyIn, &cppOut_ptr);

    return 0;
}

// Getters and Setters for InstanceTableEntry
static PyGetSetDef Sbk_QQuick3DInstancing_InstanceTableEntry_getsetlist[] = {
    {const_cast<char *>("row0"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_row0, Sbk_QQuick3DInstancing_InstanceTableEntry_set_row0},
    {const_cast<char *>("row1"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_row1, Sbk_QQuick3DInstancing_InstanceTableEntry_set_row1},
    {const_cast<char *>("row2"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_row2, Sbk_QQuick3DInstancing_InstanceTableEntry_set_row2},
    {const_cast<char *>("color"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_color, Sbk_QQuick3DInstancing_InstanceTableEntry_set_color},
    {const_cast<char *>("instanceData"), Sbk_QQuick3DInstancing_InstanceTableEntry_get_instanceData, Sbk_QQuick3DInstancing_InstanceTableEntry_set_instanceData},
    {nullptr} // Sentinel
};

} // extern "C"

static int Sbk_QQuick3DInstancing_InstanceTableEntry_traverse(PyObject *self, visitproc visit, void *arg)
{
    return SbkObject_TypeF()->tp_traverse(self, visit, arg);
}
static int Sbk_QQuick3DInstancing_InstanceTableEntry_clear(PyObject *self)
{
    return reinterpret_cast<PyTypeObject *>(SbkObject_TypeF())->tp_clear(self);
}
// Class Definition -----------------------------------------------
extern "C" {
static PyTypeObject *_Sbk_QQuick3DInstancing_InstanceTableEntry_Type = nullptr;
static PyTypeObject *Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(void)
{
    return _Sbk_QQuick3DInstancing_InstanceTableEntry_Type;
}

static PyType_Slot Sbk_QQuick3DInstancing_InstanceTableEntry_slots[] = {
    {Py_tp_base,        nullptr}, // inserted by introduceWrapperType
    {Py_tp_dealloc,     reinterpret_cast<void *>(&SbkDeallocWrapper)},
    {Py_tp_repr,        nullptr},
    {Py_tp_hash,        nullptr},
    {Py_tp_call,        nullptr},
    {Py_tp_str,         nullptr},
    {Py_tp_getattro,    nullptr},
    {Py_tp_setattro,    nullptr},
    {Py_tp_traverse,    reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_traverse)},
    {Py_tp_clear,       reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_clear)},
    {Py_tp_richcompare, nullptr},
    {Py_tp_iter,        nullptr},
    {Py_tp_iternext,    nullptr},
    {Py_tp_methods,     reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_methods)},
    {Py_tp_getset,      reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_getsetlist)},
    {Py_tp_init,        reinterpret_cast<void *>(Sbk_QQuick3DInstancing_InstanceTableEntry_Init)},
    {Py_tp_new,         reinterpret_cast<void *>(SbkObjectTpNew)},
    {0, nullptr}
};
static PyType_Spec Sbk_QQuick3DInstancing_InstanceTableEntry_spec = {
    "2:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry",
    sizeof(SbkObject),
    0,
    Py_TPFLAGS_DEFAULT|Py_TPFLAGS_BASETYPE|Py_TPFLAGS_HAVE_GC,
    Sbk_QQuick3DInstancing_InstanceTableEntry_slots
};

} //extern "C"


// Type conversion functions.

// Python to C++ pointer conversion - returns the C++ object of the Python wrapper (keeps object identity).
static void InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR(PyObject *pyIn, void *cppOut)
{
    Shiboken::Conversions::pythonToCppPointer(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(), pyIn, cppOut);
}
static PythonToCppFunc is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR_Convertible(PyObject *pyIn)
{
    if (pyIn == Py_None)
        return Shiboken::Conversions::nonePythonToCppNullPtr;
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF())))
        return InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR;
    return {};
}

// C++ to Python pointer conversion - tries to find the Python wrapper for the C++ object (keeps object identity).
static PyObject *InstanceTableEntry_PTR_CppToPython_InstanceTableEntry(const void *cppIn)
{
    auto pyOut = reinterpret_cast<PyObject *>(Shiboken::BindingManager::instance().retrieveWrapper(cppIn));
    if (pyOut) {
        Py_INCREF(pyOut);
        return pyOut;
    }
    bool changedTypeName = false;
    auto tCppIn = reinterpret_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppIn);
    const char *typeName = typeid(*tCppIn).name();
    auto sbkType = Shiboken::ObjectType::typeForTypeName(typeName);
    if (sbkType && Shiboken::ObjectType::hasSpecialCastFunction(sbkType)) {
        typeName = typeNameOf(tCppIn);
        changedTypeName = true;
    }
    PyObject *result = Shiboken::Object::newObject(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(), const_cast<void *>(cppIn), false, /* exactType */ changedTypeName, typeName);
    if (changedTypeName)
        delete [] typeName;
    return result;
}

// C++ to Python copy conversion.
static PyObject *InstanceTableEntry_COPY_CppToPython_InstanceTableEntry(const void *cppIn)
{
    return Shiboken::Object::newObject(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(), new ::QQuick3DInstancing::InstanceTableEntry(*reinterpret_cast<const ::QQuick3DInstancing::InstanceTableEntry *>(cppIn)), true, true);
}

// Python to C++ copy conversion.
static void InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY(PyObject *pyIn, void *cppOut)
{
    *reinterpret_cast<::QQuick3DInstancing::InstanceTableEntry *>(cppOut) = *reinterpret_cast< ::QQuick3DInstancing::InstanceTableEntry *>(Shiboken::Conversions::cppPointer(SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX], reinterpret_cast<SbkObject *>(pyIn)));
}
static PythonToCppFunc is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY_Convertible(PyObject *pyIn)
{
    if (PyObject_TypeCheck(pyIn, reinterpret_cast<PyTypeObject *>(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF())))
        return InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY;
    return {};
}

// The signatures string for the functions.
// Multiple signatures have their index "n:" in front.
static const char *QQuick3DInstancing_InstanceTableEntry_SignatureStrings[] = {
    "1:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry(self)",
    "0:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry(self,InstanceTableEntry:PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry)",
    "PySide6.QtQuick3D.QQuick3DInstancing.InstanceTableEntry.__copy__()",
    nullptr}; // Sentinel

void init_QQuick3DInstancing_InstanceTableEntry(PyObject *enclosingClass)
{
    _Sbk_QQuick3DInstancing_InstanceTableEntry_Type = Shiboken::ObjectType::introduceWrapperType(
        enclosingClass,
        "InstanceTableEntry",
        "QQuick3DInstancing::InstanceTableEntry",
        &Sbk_QQuick3DInstancing_InstanceTableEntry_spec,
        &Shiboken::callCppDestructor< ::QQuick3DInstancing::InstanceTableEntry >,
        0,
        0,
        Shiboken::ObjectType::WrapperFlags::InnerClass);
    auto *pyType = Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(); // references _Sbk_QQuick3DInstancing_InstanceTableEntry_Type
    InitSignatureStrings(pyType, QQuick3DInstancing_InstanceTableEntry_SignatureStrings);
    SbkObjectType_SetPropertyStrings(reinterpret_cast<PyTypeObject *>(_Sbk_QQuick3DInstancing_InstanceTableEntry_Type), Sbk_QQuick3DInstancing_InstanceTableEntry_PropertyStrings);
    SbkPySide6_QtQuick3DTypes[SBK_QQUICK3DINSTANCING_INSTANCETABLEENTRY_IDX]
        = Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF();

    // Register Converter
    SbkConverter *converter = Shiboken::Conversions::createConverter(Sbk_QQuick3DInstancing_InstanceTableEntry_TypeF(),
        InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR,
        is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_PTR_Convertible,
        InstanceTableEntry_PTR_CppToPython_InstanceTableEntry,
        InstanceTableEntry_COPY_CppToPython_InstanceTableEntry);

    Shiboken::Conversions::registerConverterName(converter, "QQuick3DInstancing::InstanceTableEntry");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DInstancing::InstanceTableEntry*");
    Shiboken::Conversions::registerConverterName(converter, "QQuick3DInstancing::InstanceTableEntry&");
    Shiboken::Conversions::registerConverterName(converter, "InstanceTableEntry");
    Shiboken::Conversions::registerConverterName(converter, "InstanceTableEntry*");
    Shiboken::Conversions::registerConverterName(converter, "InstanceTableEntry&");
    Shiboken::Conversions::registerConverterName(converter, typeid(::QQuick3DInstancing::InstanceTableEntry).name());

    // Add Python to C++ copy (value, not pointer neither reference) conversion to type converter.
    Shiboken::Conversions::addPythonToCppValueConversion(converter,
        InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY,
        is_InstanceTableEntry_PythonToCpp_InstanceTableEntry_COPY_Convertible);

    qRegisterMetaType< ::QQuick3DInstancing::InstanceTableEntry >("InstanceTableEntry");
    qRegisterMetaType< ::QQuick3DInstancing::InstanceTableEntry >("QQuick3DInstancing::InstanceTableEntry");
}
